//-----------------------------------------------------------------------------
// File name:       OSMutex.h
//-----------------------------------------------------------------------------

#ifndef _OS_MUTEX_H_
#define _OS_MUTEX_H_

//-----------------------------------------------------------------------------
// Included Files
//-----------------------------------------------------------------------------
#include <stdint.h>
#include <stdbool.h>
#include <pthread.h>

//-----------------------------------------------------------------------------
// Class Definition
//-----------------------------------------------------------------------------
class COSMutex
{
public:
    // Definitions
    typedef pthread_mutex_t OSMutex;

    // Constructor/Destructor
    COSMutex(void) = default;
    ~COSMutex(void) = default;

    // Static Functions
    static bool CreateMutex(OSMutex* createdMutex);
    static void DestroyMutex(OSMutex* mutex);

    static bool LockMutex(OSMutex* mutex);
    static bool UnlockMutex(OSMutex* mutex);
    static bool TryLockMutex(OSMutex* mutex);
};

#endif // _OS_MUTEX_H_
